package entity

import (
	"git.sxidc.com/go-framework/baize/framework/core/domain"
)

// Entity 领域实体接口
type Entity interface {
	domain.Object

	// GenerateID 生成ID
	GenerateID() error

	// GetID 获取ID
	GetID() string

	// ForCreate 创建准备方法(规则校验)
	ForCreate() error

	// ForDelete 删除准备方法(规则校验)
	ForDelete() error

	// ForUpdate 更新准备方法(规则校验)
	ForUpdate() error
}
