package value_object

import "git.sxidc.com/go-framework/baize/framework/core/domain"

// ValueObject 值对象接口
type ValueObject interface {
	domain.Object

	// CheckKeyFields 校验关键字段，关键字段值能够唯一标识一个值对象的联合主键字段
	CheckKeyFields() error

	// ForCreate 创建准备方法(规则校验)
	ForCreate() error
}
